/*! DownloadBuilder.js - v0.7.0 - 2013-12-19
* https://github.com/gfranko/DownloadBuilder.js
* Copyright (c) 2013 Greg Franko; Licensed MIT */
!function(a){"use strict";a(window,document)}(function(a,b,c){"use strict";var d=function(a){this.options={location:a&&a.location||"local",author:a&&a.author||"",repo:a&&a.repo||"",branch:a&&a.branch||"",client_id:a&&a.client_id||"",client_secret:a&&a.client_secret||"",onError:a&&a.onError||function(){}},this.options.cache=a&&a.cache!==c?+a.cache:36e5,this._create()};d.prototype={VERSION:"0.7.0",githubRateLimitUrl:"https://api.github.com/rate_limit",file:"",currentCheckbox:0,checkboxes:[],callback:function(){},_create:function(){return this.supportsFilesystem=this.fileSystemSupport(),this.github=this._isUsingGithub(),this.github.isUsing&&this._checkGithubRateLimit(),this},fileSystemSupport:function(){return a.requestFileSystem=a.requestFileSystem||a.webkitRequestFileSystem||a.mozRequestFileSystem,a.URL=a.URL||a.webkitURL||a.mozURL,a.storageInfo=a.storageInfo||navigator.webkitTemporaryStorage||a.mozStorageInfo,a.requestFileSystem&&a.Blob&&a.URL&&a.storageInfo?!0:!1},_isUsingGithub:function(){var a=b.querySelectorAll('[data-location="github"]');return a.length||"github"===this.options.location?{isUsing:!0,length:a.length}:{isUsing:!1,length:a.length}},_checkGithubRateLimit:function(){var a=this;return this.JSONP(this.githubRateLimitUrl+"?client_id="+this.options.client_id+"&client_secret="+this.options.client_secret,function(b){return b.data.rate?(a.rateLimit=b.data.rate.remaining,void 0):(a.options.onError(b.data.message),void 0)}),this},JSONP:function(d,e,f){d=d||"",e=e||"",f=f||function(){};var g,h;"function"==typeof e&&(f=e,e="callback"),h="jsonp"+Math.round(1000001*Math.random()),a[h]=function(b){f(b);try{delete a[h]}catch(d){a[h]=c}},d+=-1===d.indexOf("?")?"?":"&",g=b.createElement("script"),g.setAttribute("src",d+e+"="+h),b.getElementsByTagName("head")[0].appendChild(g)},buildURL:function(b,c,d,e){if(b.length){var f,g,h,i,j,k,l,m=this,n=(new Date).getTime();"function"==typeof e&&(m.callback=e),0===m.currentCheckbox&&a.sessionStorage&&!a.sessionStorage.getItem("cache-time")&&a.sessionStorage.setItem("cache-time",n),m.checkboxes=b,l=m.currentCheckbox===b.length-1||!1,f=b[m.currentCheckbox],g=f.getAttribute("data-location")||m.options.location||"",h=f.getAttribute("data-author")||m.options.author||"",i=f.getAttribute("data-repo")||m.options.repo||"",j=f.getAttribute("data-branch")||m.options.branch||"",k=f.getAttribute("data-localpath")||"",a.sessionStorage&&(a.sessionStorage.getItem(f.value)&&a.sessionStorage.getItem("cache-time")?n-a.sessionStorage.getItem("cache-time")>=m.options.cache?(a.sessionStorage.removeItem(f.value),a.sessionStorage.removeItem("cache-time"),m._sendRequest({location:g,repoAuthor:h,repoName:i,repoBranch:j,localPath:k,currentElem:f,time:n,lastElem:l,fileName:c,lang:d})):(m.file+=a.sessionStorage.getItem(f.value),m._fileStatus({lastElem:l,lang:d,fileName:c})):m._sendRequest({location:g,repoAuthor:h,repoName:i,repoBranch:j,localPath:k,currentElem:f,time:n,lastElem:l,fileName:c,lang:d}))}else e.call(a,{content:"",fileName:c,lang:d});return this},_localRequest:function(b){var c,d,e=this;try{c=new XMLHttpRequest,c.open("GET",b.url,!0),c.onreadystatechange=function(){4===this.readyState&&200===this.status&&(d=this.responseText||this.response||"",e.file+=e.file?"\n"+d:d,a.sessionStorage.setItem(b.elem.value,d||""),e._fileStatus({lastElem:b.lastElem,lang:b.lang,fileName:b.fileName}))},c.send()}catch(f){}return this},_thirdPartyRequest:function(b){var c,d=this;this.JSONP(b.url,function(e){"github"===b.type&&(c=d._parseGithubResponse({elem:b.elem,data:e})||"",d.file+=d.file?"\n"+c:c,a.sessionStorage.setItem(b.elem.value,c||""),d._fileStatus({lastElem:b.lastElem,lang:b.lang,fileName:b.fileName}))})},_sendRequest:function(a){"github"===a.location?0!==this.rateLimit?(this.rateLimit-=1,this._thirdPartyRequest({type:a.location,url:"https://api.github.com/repos/"+a.repoAuthor+"/"+a.repoName+"/contents/"+a.currentElem.value+"?ref="+a.repoBranch+"&client_id="+this.options.client_id+"&client_secret="+this.options.client_secret,elem:a.currentElem,time:a.time,lastElem:a.lastElem,lang:a.lang,fileName:a.fileName})):a.localPath&&this._localRequest({url:a.localpath,elem:a.currentElem,time:a.time,lastElem:a.lastElem,lang:a.lang,fileName:a.fileName}):this._localRequest({url:a.currentElem.value,elem:a.currentElem,time:a.time,lastElem:a.lastElem,lang:a.lang,fileName:a.fileName})},_parseGithubResponse:function(b){var d,e,f,g;return b.data.data.content!==c&&a.atob&&"base64"===b.data.data.encoding&&(d=b.data.data.content,d=d.replace(/\n/g,""),e=a.atob(d),f=e.split("\n"),g=f.slice(0,f.length).join("\n")||""),g},createURL:function(b){var c,d=this;return a.storageInfo.requestQuota(1048576,function(e){a.requestFileSystem(d.storageType,e,function(d){d.root.getFile(b.fileName,{create:!0},function(d){d.createWriter(function(){c=new a.Blob([b.data],{type:"text/"+b.lang}),b.callback.call(a,a.URL.createObjectURL(c))})})})}),this},_fileStatus:function(b){var c=this;return b.lastElem?(this.currentCheckbox=0,c.supportsFilesystem?c.createURL({lang:b.lang,fileName:b.fileName,data:c.file,callback:function(d){a.sessionStorage.setItem("bloburl",d),c.callback.call(a,{url:d,content:c.file,fileName:b.fileName,lang:b.lang}),c.file=""}}):(c.callback.call(a,{content:c.file,fileName:b.fileName,lang:b.lang}),c.file="")):(this.currentCheckbox+=1,c.buildURL(c.checkboxes,b.fileName,b.lang,c.callback)),this}},a.DownloadBuilder=d});